//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 LimeGreen
#property indicator_color3 PaleVioletRed
#property indicator_color4 HotPink
#property indicator_color5 Silver
#property indicator_color6 Silver
#property indicator_color7 Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern int  LwmaPeriod      = 20;
extern int  LwmaPrice       = PRICE_CLOSE;
extern int  EmaPeriod       = 10;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

double slope[];
double ema1[];
double ema2[];
double slopeuu[];
double slopeud[];
double slopedu[];
double slopedd[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{      
   IndicatorDigits(6);    
   IndicatorBuffers(8);    
   SetIndexBuffer(0,slopeud); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,slopeuu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,slopedd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,slopedu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,slope);
   SetIndexBuffer(5,ema1);
   SetIndexBuffer(6,ema2);
   SetIndexBuffer(7,trend);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);   

   //
   //
   //
   //
   //
   
      double alpha = 2.0/(1.0+EmaPeriod);
      for (int i=limit; i>=0; i--)
      {
         if (Bars-i<=LwmaPeriod) { slope[i] = 0; ema1[i] = 0; ema2[i] = 0; continue; }            
         slope[i] = (iMA(NULL,0,LwmaPeriod+1,0,MODE_LWMA,LwmaPrice,i)-calcWhatever(LwmaPeriod,i));
         if (slope[i]>slope[i+1])
               ema1[i] = ema1[i+1]+alpha*(slope[i]-ema1[i+1]);
         else  ema1[i] = ema1[i+1];
         if (slope[i]<slope[i+1])
               ema2[i] = ema2[i+1]+alpha*(slope[i]-ema2[i+1]);
         else  ema2[i] = ema2[i+1];
         
         //
         //
         //
         //
         //

         trend[i] = trend[i+1];         
            if (slope[i]>slope[i+1]) trend[i] =  1;
            if (slope[i]<slope[i+1]) trend[i] = -1;
         slopeuu[i] = EMPTY_VALUE;
         slopeud[i] = EMPTY_VALUE;
         slopedd[i] = EMPTY_VALUE;
         slopedu[i] = EMPTY_VALUE;
            if (slope[i]>ema1[i])          { slopeuu[i] = slope[i]; continue; }
            if (slope[i]>slope[i+1])       { slopeud[i] = slope[i]; continue; }
            if (slope[i]<ema2[i])          { slopedu[i] = slope[i]; continue; }
            if (slope[i]<slope[i+1])       { slopedd[i] = slope[i]; continue; }
      }
//      Comment(trend[1],"   ",trend[2]);
      manageAlerts();
      return( 0 );
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double calcWhatever( int period, int i)
{
   double Sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+1)+period*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i);
   double Sumw = (period+1)+period;
   int j,k;

      //
      //
      //
      //
      //
      
      for (j=1, k=period; j <= period; j++,k-- )
      {
         Sum  += k*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+j+1);
         Sumw += k;
      }

   return( Sum / Sumw );
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Lwma slope changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" Lwma slope ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

